Package ec.rule

# Class Rule

java.lang.Object
ec.rule.Rule

All Implemented Interfaces:
  `Prototype`, `Setup`, `Serializable`, `Cloneable`, `Comparable`

public abstract class Rule extends Object implements Prototype, Comparable
Rule is an abstract class for describing rules. It is abstract because it is supposed to be extended by different classes modelling different kinds of rules. It provides the reset abstract method for randomizing the individual. It also provides the mutate function for mutating an individual rule It also provides the clone function for cloning the rule.

You will need to implement some kind of artificial ordering between rules in a ruleset using the Comparable interface, so the ruleset can be sorted in such a way that it can be compared with another ruleset for equality. You should also implement hashCode and equals in such a way that they aren't based on pointer information, but on actual internal features.

Every rule points to a RuleConstraints which handles information that Rule shares with all the other Rules in a RuleSet.

In addition to serialization for checkpointing, Rules may read and write themselves to streams in three ways.

- writeRule(...,DataOutput)/readRule(...,DataInput) This method transmits or receives a Rule in binary. It is the most efficient approach to sending Rules over networks, etc. The default versions of writeRule/readRule throw errors. You don't need to implement them if you don't plan on using read/writeRule.
- printRule(...,PrintWriter)/readRule(...,LineNumberReader) This approach transmits or receives a Rule in text encoded such that the Rule is largely readable by humans but can be read back in 100% by ECJ as well. To do this, these methods will typically encode numbers using the `ec.util.Code` class. These methods are mostly used to write out populations to files for inspection, slight modification, then reading back in later on. readRule reads in a line, then calls readRuleFromString on that line. You are responsible for implementing readRuleFromString: the Code class is there to help you. The default version throws an error if called. printRule calls printRuleToString and printlns the resultant string. You are responsible for implementing the printRuleToString method in such a way that readRuleFromString can read back in the Rule println'd with printRuleToString. The default form of printRuleToString() simply calls toString() by default. You might override printRuleToString() to provide better information. You are not required to implement these methods, but without them you will not be able to write Rules to files in a simultaneously computer- and human-readable fashion.
- printRuleForHumans(...,PrintWriter) This approach prints a Rule in a fashion intended for human consumption only. printRuleForHumans calls printRuleToStringForHumans() and printlns the resultant string. The default form of this method just returns the value of toString(). You may wish to override this to provide more information instead. You should handle one of these methods properly to ensure Rules can be printed by ECJ.

Parameters

base.`constraints` string | (name of the rule constraint)

Default Base
rule.rule

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `byte`
  `constraints`
  An index to a RuleConstraints
  `static final String`
  `P_CONSTRAINTS`
  `static final String`
  `P_RULE`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Rule()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.
  `abstract int`
  `compareTo(Object o)`
  This function replaces the old gt and lt functions that Rule used to require as it implemented the SortComparator interface.
  `final RuleConstraints`
  `constraints(RuleInitializer initializer)`
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `boolean`
  `equals(Object other)`
  Unlike the standard form for Java, this function should return true if this rule is "genetically identical" to the other rule.
  `abstract int`
  `hashCode()`
  Rulerates a hash code for this rule -- the rule for this is that the hash code must be the same for two rules that are equal to each other genetically.
  `void`
  `mutate(EvolutionState state, int thread)`
  Mutate the rule.
  `void`
  `printRule(EvolutionState state, int log)`
  Prints the rule in a way that can be read by readRule().
  `void`
  `printRule(EvolutionState state, int log, int verbosity)`
  Prints the rule in a way that can be read by readRule().
  `void`
  `printRule(EvolutionState state, PrintWriter writer)`
  Prints the rule in a way that can be read by readRule().
  `void`
  `printRuleForHumans(EvolutionState state, int log)`
  Nice printing.
  `void`
  `printRuleForHumans(EvolutionState state, int log, int verbosity)`
  Nice printing.
  `String`
  `printRuleToString()`
  Prints the rule to a string in a fashion readable by readRuleFromString.
  `String`
  `printRuleToString(EvolutionState state)`
  Prints the rule to a string in a fashion readable by readRuleFromString.
  `String`
  `printRuleToStringForHumans()`
  Nice printing to a string.
  `void`
  `readRule(EvolutionState state, DataInput dataInput)`
  Override this if you need to read rules in from a binary stream
  `void`
  `readRule(EvolutionState state, LineNumberReader reader)`
  Reads a rule printed by printRule(...).
  `void`
  `readRuleFromString(String string, EvolutionState state)`
  Reads a rule from a string, which may contain a final '\n'.
  `abstract void`
  `reset(EvolutionState state, int thread)`
  The reset method randomly reinitializes the rule.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the object by reading it from the parameters stored in state, built off of the parameter base base.
  `void`
  `writeRule(EvolutionState state, DataOutput dataOutput)`
  Override this if you need to write rules out to a binary stream

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_RULE

    public static final String P_RULE
    See Also:
      - Constant Field Values

  - ### P_CONSTRAINTS

    public static final String P_CONSTRAINTS
    See Also:
      - Constant Field Values

  - ### constraints

    public byte constraints
    An index to a RuleConstraints

- ## Constructor Details

  - ### Rule

    public Rule()

- ## Method Details

  - ### constraints

    public final RuleConstraints constraints(RuleInitializer initializer)

  - ### hashCode

    public abstract int hashCode()
    Rulerates a hash code for this rule -- the rule for this is that the hash code must be the same for two rules that are equal to each other genetically.
    Overrides:
      `hashCode` in class `Object`

  - ### equals

    public boolean equals(Object other)
    Unlike the standard form for Java, this function should return true if this rule is "genetically identical" to the other rule. The default calls compareTo()
    Overrides:
      `equals` in class `Object`

  - ### reset

    public abstract void reset(EvolutionState state, int thread)
    The reset method randomly reinitializes the rule.

  - ### mutate

    public void mutate(EvolutionState state, int thread)
    Mutate the rule. The default form just resets the rule.

  - ### printRuleForHumans

    public void printRuleForHumans(EvolutionState state, int log)
    Nice printing. The default form simply calls printRuleToStringForHumans and prints the result, but you might want to override this.

  - ### printRuleForHumans

    public void printRuleForHumans(EvolutionState state, int log, int verbosity)
    Nice printing. The default form simply calls printRuleToStringForHumans and prints the result, but you might want to override this.

  - ### printRuleToStringForHumans

    public String printRuleToStringForHumans()
    Nice printing to a string. The default form calls toString().

  - ### printRuleToString

    public String printRuleToString(EvolutionState state)
    Prints the rule to a string in a fashion readable by readRuleFromString. The default form calls printRuleToString().

  - ### printRuleToString

    public String printRuleToString()
    Prints the rule to a string in a fashion readable by readRuleFromString. The default form simply calls toString() -- you should just override toString() if you don't need the EvolutionState.

  - ### readRuleFromString

    public void readRuleFromString(String string, EvolutionState state)
    Reads a rule from a string, which may contain a final '\n'. Override this method. The default form generates an error.

  - ### printRule

    public void printRule(EvolutionState state, int log)
    Prints the rule in a way that can be read by readRule(). The default form simply calls printRuleToString(state). Override this rule to do custom writing to the log, or just override printRuleToString(...), which is probably easier to do.

  - ### printRule

    public void printRule(EvolutionState state, int log, int verbosity)
    Prints the rule in a way that can be read by readRule(). The default form simply calls printRuleToString(state). Override this rule to do custom writing to the log, or just override printRuleToString(...), which is probably easier to do.

  - ### printRule

    public void printRule(EvolutionState state, PrintWriter writer)
    Prints the rule in a way that can be read by readRule(). The default form simply calls printRuleToString(state). Override this rule to do custom writing, or just override printRuleToString(...), which is probably easier to do.

  - ### readRule

    public void readRule(EvolutionState state, LineNumberReader reader) throws IOException
    Reads a rule printed by printRule(...). The default form simply reads a line into a string, and then calls readRuleFromString() on that line. Override this rule to do custom reading, or just override readRuleFromString(...), which is probably easier to do.
    Throws:
      `IOException`

  - ### writeRule

    public void writeRule(EvolutionState state, DataOutput dataOutput) throws IOException
    Override this if you need to write rules out to a binary stream
    Throws:
      `IOException`

  - ### readRule

    public void readRule(EvolutionState state, DataInput dataInput) throws IOException
    Override this if you need to read rules in from a binary stream
    Throws:
      `IOException`

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).
    Specified by:
      `defaultBase` in interface `Prototype`

  - ### clone

    public Object clone()
    Description copied from interface: `Prototype`
    Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.

    Typically this should be a full "deep" clone. However, you may share certain elements with other objects rather than clone hem, depending on the situation:

    - If you hold objects which are shared with other instances, don't clone them.
    - If you hold objects which must be unique, clone them.
    - If you hold objects which were given to you as a gesture of kindness, and aren't owned by you, you probably shouldn't clone them.
    - DON'T attempt to clone: Singletons, Cliques, or Populations, or Subpopulation.
    - Arrays are not cloned automatically; you may need to clone an array if you're not sharing it with other instances. Arrays have the nice feature of being copyable by calling clone() on them.

    Implementations.

    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are abstract, then you should not declare clone().
    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are not abstract, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   return super.clone();
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               }

    - If no ancestor of yours implements clone(), but you need to deep-clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   MyObject myobj = (MyObject) (super.clone());

                   // put your deep-cloning code here...
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               return myobj;
               }

    - If an ancestor has implemented clone(), and you also need to deep clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               MyObject myobj = (MyObject) (super.clone());

               // put your deep-cloning code here...

               return myobj;
               }

    Specified by:
      `clone` in interface `Prototype`
    Overrides:
      `clone` in class `Object`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from interface: `Prototype`
    Sets up the object by reading it from the parameters stored in state, built off of the parameter base base. If an ancestor implements this method, be sure to call super.setup(state,base); before you do anything else.

    For prototypes, setup(...) is typically called once for the prototype instance; cloned instances do not receive the setup(...) call. setup(...) may be called more than once; the only guarantee is that it will get called at least once on an instance or some "parent" object from which it was ultimately cloned.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`

  - ### compareTo

    public abstract int compareTo(Object o)
    This function replaces the old gt and lt functions that Rule used to require as it implemented the SortComparator interface. If you had implemented those old functions, you can simply implement this function as: `

                public abstract int compareTo(Object o)
                {
                if (gt(this,o)) return 1;
                if (lt(this,o)) return -1;
                return 0;
                }

    `
    Specified by:
      `compareTo` in interface `Comparable`